//
// Vertical Scroll Test Code
//

#include "stdafx.h"

#include <DDraw.h>
#include <ISTBTDDExt.h>

#include "tulsa sample app.h"
#include "mainfrm.h"
#include "CardDlg.h"
#include "InitCardDlg.h"
#include "dibapi.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

#undef TEST_ABS_NOTIF
#define READ_SCROLL_DEBUG_COUNTER

#define TEXT_HEIGHT_VS		70
#define TEXT_SPACE_VS		10

#define UPDATE_SIZE_VS		100 //155 
#define SRC_HEIGHT_VS		480
#define SRC_WIDTH_VS		720

#define MOVE_WINDOW_DELAY	5

#define TIMEBAR_HEIGHT	70
#define TIMEBAR_WIDTH	720

void CCardDlg::ReadScrollBitmap(char* szFilename, SCROLL_DIB_INFO &ScrollDIBInfo)
{
	BITMAPINFOHEADER bi;
	if ((ScrollDIBInfo.hDib = OpenDIB(szFilename, &bi)) != NULL) {
		
		ScrollDIBInfo.dwWidth = bi.biWidth;
		ScrollDIBInfo.dwHeight = bi.biHeight;
		ScrollDIBInfo.BytesPerPixel = bi.biBitCount/8;
		ScrollDIBInfo.BytesPerRow = ScrollDIBInfo.BytesPerPixel*bi.biWidth;
											// DWORD align row
		if (ScrollDIBInfo.BytesPerRow % 4) {
			ScrollDIBInfo.BytesPerRow += 4 - (ScrollDIBInfo.BytesPerRow % 4);
		}
	    ScrollDIBInfo.pDIBHdr = (LPBITMAPINFO)GlobalLock(ScrollDIBInfo.hDib);
		ScrollDIBInfo.pDIBBits = (BYTE*)FindDIBBits((char*)ScrollDIBInfo.pDIBHdr);
	}
}


void CCardDlg::FreeScrollBitmap(SCROLL_DIB_INFO &ScrollDIBInfo)
{
	if (ScrollDIBInfo.hDib) {
		GlobalUnlock(ScrollDIBInfo.hDib);
		GlobalFree(ScrollDIBInfo.hDib);
		ScrollDIBInfo.hDib = NULL;
	}
}

void DrawOverlayTestPatternVert(int DrawOffset, int BufferOffset, int Size,
		LPDIRECTDRAWSURFACE lpDDS, CGraphicsContent* pGraphicsContent)
{
	int x, y;
	DDSURFACEDESC SurfaceDesc;
	int Count;

	DWORD AlphaValue = pGraphicsContent->m_StartingAlpha << 24;

	if (lpDDS->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {

		CDC DC; 
		DC.Attach(GetDC(NULL));

		DWORD height = Size; 
		DWORD width = SRC_WIDTH_VS; 
		DWORD Stride = SurfaceDesc.lPitch;
		DWORD BytesPerPixel = SurfaceDesc.ddpfPixelFormat.dwRGBBitCount/8;	// only 16 & 32 supported
		LPVOID lpSurface = SurfaceDesc.lpSurface;

		CRect rect = CRect(0, 0, width , height);
		CBitmap Bmp;
		if (Bmp.CreateCompatibleBitmap(&DC, width, height)) {

			CDC MemDC;
			if (MemDC.CreateCompatibleDC(&DC)) {
				CBitmap* pBmpOld = MemDC.SelectObject(&Bmp);

				CBrush brush(RGB(255, 255, 255));

				MemDC.FillRect(&rect, &brush);
				CBrush *pBrushOld = MemDC.SelectObject(&brush);

				CPen *pPen = new CPen(PS_SOLID, 8, RGB(0, 0, 0));
				CPen *pPenOld2 = MemDC.SelectObject(pPen);

				int YEnd;
				int YStart = 0 - (DrawOffset % width);
				do {
					YEnd = YStart + width;

					MemDC.MoveTo(width -1, YStart - 1);
					MemDC.LineTo(-1, YStart - 1);

					MemDC.MoveTo(- 10, YStart - 10);
					MemDC.LineTo(width + 10, YEnd + 10);	// +delta so that round endpoint is not seen

					MemDC.MoveTo(width - 1, YEnd - 1);
					MemDC.LineTo(-1, YEnd - 1);

					YStart += width;
				} while (YStart < Size);


				LOGFONT logFont;
				logFont.lfHeight = TEXT_HEIGHT_VS;
				logFont.lfWidth = 0; 
				logFont.lfEscapement = 0; 
				logFont.lfOrientation = 0; 
				logFont.lfWeight = FW_BOLD; 
				logFont.lfItalic = FALSE; 
				logFont.lfUnderline = FALSE; 
				logFont.lfStrikeOut = FALSE; 
				logFont.lfCharSet = DEFAULT_CHARSET;
				logFont.lfOutPrecision = OUT_DEFAULT_PRECIS; 
				logFont.lfClipPrecision = CLIP_DEFAULT_PRECIS; 
				logFont.lfQuality = DEFAULT_QUALITY; 
				logFont.lfPitchAndFamily = DEFAULT_PITCH; 
				strcpy(logFont.lfFaceName, "Arial");


				CFont font;
				CFont font2, font3, font4, font5, font6, font7;
				if (font.CreateFontIndirect(&logFont) != 0) {
		
					logFont.lfHeight = TEXT_HEIGHT_VS*7/8;
					font2.CreateFontIndirect(&logFont);
					
					logFont.lfHeight = TEXT_HEIGHT_VS*6/8;
					font3.CreateFontIndirect(&logFont);

					logFont.lfHeight = TEXT_HEIGHT_VS*5/8;
					font4.CreateFontIndirect(&logFont);

					logFont.lfHeight = TEXT_HEIGHT_VS*4/8;
					font5.CreateFontIndirect(&logFont);

					logFont.lfHeight = TEXT_HEIGHT_VS*3/8;
					font6.CreateFontIndirect(&logFont);

					logFont.lfHeight = TEXT_HEIGHT_VS*2/8;
					font7.CreateFontIndirect(&logFont);
					
					CFont *pOldFont = MemDC.SelectObject(&font);

					MemDC.SetBkMode(TRANSPARENT);
					MemDC.SetTextColor(RGB(0, 0, 0x80));

					CPen CPenThin(PS_SOLID, 1, RGB(0, 0, 0));
					MemDC.SelectObject(&CPenThin);

					RECT rect;
					char TextBuffer[50];
					rect.left = 20;
					rect.right = 600;
					int y = -1*(DrawOffset % (TEXT_HEIGHT_VS + TEXT_SPACE_VS));  
					Count = DrawOffset/(TEXT_HEIGHT_VS + TEXT_SPACE_VS);
					do {
						rect.top = y;
						rect.bottom = y + TEXT_HEIGHT_VS + TEXT_SPACE_VS;
						sprintf(TextBuffer, "%04d", Count);
						Count++;

						CRect rectDraw = rect;

						MemDC.DrawText(TextBuffer, -1, &rectDraw, /*DT_CENTER | DT_VCENTER |*/ DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						MemDC.DrawText(TextBuffer, -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						rectDraw.left = rectDraw.right + 20;
						rectDraw.bottom = rect.bottom;
						rectDraw.top = rect.top;
						MemDC.SelectObject(&font2);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						rectDraw.left = rectDraw.right + 20;
						rectDraw.bottom = rect.bottom;
						rectDraw.top = rect.top;
						MemDC.SelectObject(&font3);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						rectDraw.left = rectDraw.right + 20;
						rectDraw.bottom = rect.bottom;
						rectDraw.top = rect.top;
						MemDC.SelectObject(&font4);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						rectDraw.left = rectDraw.right + 20;
						rectDraw.bottom = rect.bottom;
						rectDraw.top = rect.top;
						MemDC.SelectObject(&font5);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						rectDraw.left = rectDraw.right + 20;
						rectDraw.bottom = rect.bottom;
						rectDraw.top = rect.top;
						MemDC.SelectObject(&font6);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						rectDraw.left = rectDraw.right + 20;
						rectDraw.bottom = rect.bottom;
						rectDraw.top = rect.top;
						MemDC.SelectObject(&font7);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_CALCRECT | DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);
						MemDC.DrawText("Abc", -1, &rectDraw, DT_BOTTOM | DT_SINGLELINE | DT_NOCLIP);

						MemDC.SelectObject(&font);

						MemDC.MoveTo(0, y);
						MemDC.LineTo(50, y);

						y += TEXT_HEIGHT_VS + TEXT_SPACE_VS;
					} while (rect.bottom < Size);

					MemDC.SelectObject(pOldFont);
				}
				
				
				MemDC.SelectObject(pPenOld2);
				delete pPen;

				MemDC.SelectObject(pBrushOld);
				MemDC.SelectObject(pBmpOld);
			}

			LPBITMAPINFO pDIBHdr;
			BYTE *pDIBBits; 

			BITMAP bm;
					// Get bitmap dimensions
		    GetObject(Bmp, sizeof(bm), (LPSTR)&bm);

			HDIB hDib = DibFromBitmap((HBITMAP)Bmp, BI_RGB, 32, NULL);
			if (hDib != NULL) {
			    pDIBHdr = (LPBITMAPINFO)GlobalLock(hDib);
				pDIBBits = (BYTE*)FindDIBBits((char*)pDIBHdr);

				width *= 4;
				DWORD PixColor;
				for (y = 0; y < (int)height; y++) {
					DWORD SrcRowOffset = (height - y - 1)*bm.bmWidth*4;
					DWORD DestRowOffset = (y + BufferOffset)*Stride;
					for (x = 0; x < (int)width; x += 4) {
						PixColor = *(DWORD*)((DWORD)pDIBBits + SrcRowOffset + x);
						*(DWORD*)((DWORD)lpSurface + DestRowOffset + x) = PixColor | AlphaValue;
					}
				}
				GlobalUnlock(hDib);
				GlobalFree(hDib);
			}
		}
		ReleaseDC(NULL, DC.Detach());

		lpDDS->Unlock(NULL);
	}
}

void DrawOverlayBitmapVert(int DrawOffset, int BufferOffset, int Size,
		LPDIRECTDRAWSURFACE lpDDS, SCROLL_DIB_INFO* pScrollDibInfo,
		CGraphicsContent* pGraphicsContent)
{
	int x, y;
	DDSURFACEDESC SurfaceDesc;
	DWORD AlphaValue;
	DWORD AlphaMask;

	if (pGraphicsContent->m_AlphaSource == ALPHA_SRC_GENERATE) {
		AlphaValue = pGraphicsContent->m_StartingAlpha << 24;
		AlphaMask = 0xff000000;
	} else {
		AlphaValue = 0;
		AlphaMask = 0x00000000;
	}

	if (lpDDS->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {

		DWORD height = Size; 
		DWORD width = SRC_WIDTH_VS; 
		DWORD Stride = SurfaceDesc.lPitch;
		DWORD BytesPerPixel = SurfaceDesc.ddpfPixelFormat.dwRGBBitCount/8;	// only 16 & 32 supported
		LPVOID lpSurface = SurfaceDesc.lpSurface;

		if (pScrollDibInfo->hDib != NULL) {
			width *= 4;
			DWORD PixColor;

			DWORD DibOffset = DrawOffset % pScrollDibInfo->dwHeight;

			for (y = 0; y < (int)height; y++) {
				int DibRow = (pScrollDibInfo->dwHeight - DibOffset - y - 1);
				if (DibRow < 0) {
					DibRow += pScrollDibInfo->dwHeight;
				}

				DWORD SrcRowOffset = (DWORD)DibRow*pScrollDibInfo->BytesPerRow;
				DWORD DestRowOffset = (y + BufferOffset)*Stride;

				int xs;
				for (x = 0, xs = 0; x < (int)width; x += 4, xs += pScrollDibInfo->BytesPerPixel) {

					if (pScrollDibInfo->BytesPerPixel == 4) {
						PixColor = *(DWORD*)((DWORD)pScrollDibInfo->pDIBBits + SrcRowOffset + xs);
					} else if (pScrollDibInfo->BytesPerPixel == 3) {
						PixColor = ((DWORD)*(pScrollDibInfo->pDIBBits + SrcRowOffset + xs)) |
							(((DWORD)*(pScrollDibInfo->pDIBBits + SrcRowOffset + xs + 1)) << 8) |
							(((DWORD)*(pScrollDibInfo->pDIBBits + SrcRowOffset + xs + 2)) << 16);
					} else {				// Not supported
						PixColor = 0;		
					}

					PixColor &= ~AlphaMask;

					*(DWORD*)((DWORD)lpSurface + DestRowOffset + x) = PixColor | AlphaValue;
				}
			}
		}

		lpDDS->Unlock(NULL);
	}
}


UINT VertScrollThread(LPVOID lpvParam)
{
	HRESULT result;
	RECT SrcRect;
	RECT SrcRectTB;
	RECT DestRect;
	BOOL bUpdate = FALSE;
	int StopPoint = 0;
	POINT FilterStart;
	SIZE FilterSize;
	BOOL bFinished;
	DWORD Line;
	CCardDlg *pCCardDlg = (CCardDlg*)lpvParam;	
	CGraphicsContent content = pCCardDlg->pVScrollOvly->m_Content;
	int MoveWindowDelay = 0;
	int WindowPosScrollArea;
	int WindowPosTimebar;

	BOOL bMoveWindowUp = FALSE;

	CoInitialize(NULL);

	int error = 0;
	int WakeCnt = 0;
	int Offset = 0;
	int BufferPosition = 0;
	int FillSize = SRC_HEIGHT_VS;
	int NextUpdatePosition = 0;

	if (pCCardDlg->m_ConfigPreset == PREVUE_DEMO_SETTINGS) {
		WindowPosScrollArea = pCCardDlg->pVScrollOvly->m_Position.y + TIMEBAR_HEIGHT;
		WindowPosTimebar = pCCardDlg->pVScrollOvly->m_Position.y;

		SrcRectTB.left = 0;
		SrcRectTB.top = 0;
		SrcRectTB.right = SrcRectTB.left + TIMEBAR_WIDTH - 1;
		SrcRectTB.bottom = SrcRectTB.top + TIMEBAR_HEIGHT - 1;
		DestRect.left = pCCardDlg->pVScrollOvly->m_Position.x;
		DestRect.top = WindowPosTimebar;
		DestRect.right = DestRect.left + pCCardDlg->pVScrollOvly->m_Size.cx - 1;
		DestRect.bottom = DestRect.top + TIMEBAR_HEIGHT - 1;

		if (pCCardDlg->lpDDSOverlayTimebar) {
			pCCardDlg->lpDDSOverlayTimebar->UpdateOverlay(&SrcRectTB, pCCardDlg->lpDDSPrimaryRGB, 
				&DestRect, DDOVER_SHOW, NULL);
		}

	} else {
		WindowPosScrollArea = pCCardDlg->pVScrollOvly->m_Position.y;
	}


	if (content.m_Source == SRC_BMP_FILE) {
		DrawOverlayBitmapVert(Offset, BufferPosition, FillSize, pCCardDlg->lpDDSOverlayVScroll, &pCCardDlg->m_VScrollDibInfo, &content);
	} else { 
		DrawOverlayTestPatternVert(Offset, BufferPosition, FillSize, pCCardDlg->lpDDSOverlayVScroll, &content);
	}

	Offset += FillSize;

	LPTULSASURFACEEXT lpTulsaSurfaceExt;

	result = CoCreateInstance(CLSID_STBTDDExtension, NULL, 
		CLSCTX_INPROC, IID_ISTBTDDSurfaceExt, (LPVOID *)&lpTulsaSurfaceExt);

	if (result != DD_OK) {
		pCCardDlg->lpDDSOverlayVScroll->Release();
		pCCardDlg->lpDDSOverlayVScroll = NULL;

		pCCardDlg->bVertScrollThreadFinished = TRUE;

		CoUninitialize();
		return(0);
	}

	pCCardDlg->hEventVertFF = CreateEvent(NULL, FALSE, FALSE, NULL);
											// Assign surface being extended
	lpTulsaSurfaceExt->AssignSurface(pCCardDlg->lpDDSOverlayVScroll);

	if (pCCardDlg->pVScrollOvly->m_bFilter) {
		FilterStart.x = 0;
		FilterStart.y = 0;
		FilterSize.cx = SRC_WIDTH_VS;
		FilterSize.cy = SRC_HEIGHT_VS - 1;	// Don't filter the last line since it depends upon
											//  the next line after it
		ResetEvent(pCCardDlg->hEventVertFF);
		if (lpTulsaSurfaceExt->StartFlickerFilter(&FilterStart, &FilterSize, pCCardDlg->hEventVertFF) != DD_OK) {
			error++;
		}
		do {
			WaitForSingleObject(pCCardDlg->hEventVertFF, INFINITE /*100*/);
			lpTulsaSurfaceExt->GetFlickerFilterStatus(&bFinished, &Line);
		} while (!bFinished && pCCardDlg->bEnableVertScrollThread);
	}
	SrcRect.left = 0;
	SrcRect.top = 0;
	SrcRect.right = SrcRect.left + SRC_WIDTH_VS - 1;
	SrcRect.bottom = SrcRect.top + SRC_HEIGHT_VS - 1;
	DestRect.left = pCCardDlg->pVScrollOvly->m_Position.x;
	DestRect.top = WindowPosScrollArea;
	DestRect.right = DestRect.left + pCCardDlg->pVScrollOvly->m_Size.cx - 1;
	DestRect.bottom = DestRect.top + pCCardDlg->pVScrollOvly->m_Size.cy - 1;

	pCCardDlg->hEventVertScroll = CreateEvent(NULL, FALSE, FALSE, NULL);

	SURFACEDESCEXT SurfaceDescExt;
	INIT_DIRECTDRAW_STRUCT(SurfaceDescExt);
	SurfaceDescExt.dwFlags = SDE_SCROLL_VERT | SDE_SCROLL_SET_SRC_POS;

	SurfaceDescExt.lScrollPixelsPerStep = pCCardDlg->pVScrollOvly->m_PixelsPerStep;
	SurfaceDescExt.dwScrollVerticalsPerStep = pCCardDlg->pVScrollOvly->m_VerticalsPerStep;
	SurfaceDescExt.dwScrollPausePosition = SRC_HEIGHT_VS - pCCardDlg->pVScrollOvly->m_Size.cy;
	SurfaceDescExt.dwScrollPosition = 0;

#ifdef TEST_ABS_NOTIF
	SurfaceDescExt.dwScrollNotifPosition = SurfaceDescExt.dwScrollPausePosition - 10;
	if (SurfaceDescExt.dwScrollNotifPosition < 0) {
		SurfaceDescExt.dwScrollNotifPosition += SRC_HEIGHT_VS;
	}
	SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
#else
	if (SurfaceDescExt.lScrollPixelsPerStep > 0) {
		SurfaceDescExt.dwScrollNotifIncrement = (SRC_HEIGHT_VS - UPDATE_SIZE_VS - pCCardDlg->pVScrollOvly->m_Size.cy)/(2*SurfaceDescExt.lScrollPixelsPerStep);
		if (SurfaceDescExt.dwScrollNotifIncrement == 0) {
			SurfaceDescExt.dwScrollNotifIncrement = 1;
		}
	} else {
		SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
	}
	SurfaceDescExt.dwScrollNotifPosition = 0xffffffff;
#endif

	SurfaceDescExt.hScrollEvent = pCCardDlg->hEventVertScroll;

	SurfaceDescExt.bPreserveDestAlpha = !pCCardDlg->pVScrollOvly->m_bWriteAlpha;
	lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

	if (pCCardDlg->VScrollZOrderFlags) {
		pCCardDlg->lpDDSOverlayVScroll->UpdateOverlayZOrder(pCCardDlg->VScrollZOrderFlags & 0xfffffff, NULL);
		pCCardDlg->VScrollZOrderFlags = 0;
	}

	pCCardDlg->lpDDSOverlayVScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, 
		&DestRect, DDOVER_SHOW | (pCCardDlg->pVScrollOvly->m_bBlend? DDOVER_ALPHASRC: 0) | 
		(pCCardDlg->pVScrollOvly->m_bInvBlend? DDOVER_ALPHASRCNEG: 0), NULL);

	int FirstDrawingPassSize;
	int SecondDrawingPassSize;

	pCCardDlg->VScrollReady = TRUE;

	while(pCCardDlg->bEnableVertScrollThread) {
		lpTulsaSurfaceExt->GetSurfaceDescExt(&SurfaceDescExt);

		pCCardDlg->DbgVScrollPos = SurfaceDescExt.dwScrollPosition;

		int PixelsAway = SurfaceDescExt.dwScrollPosition - NextUpdatePosition;
		if (PixelsAway < 0) {
			PixelsAway += SRC_HEIGHT_VS;
		}
		if (PixelsAway >= UPDATE_SIZE_VS) {
			pCCardDlg->m_bVSUpdate = FALSE;
			int LastUpdatePos = NextUpdatePosition + UPDATE_SIZE_VS - 1;
			if (LastUpdatePos >= SRC_HEIGHT_VS) {
				SecondDrawingPassSize = LastUpdatePos - SRC_HEIGHT_VS;
				FirstDrawingPassSize = SRC_HEIGHT_VS - NextUpdatePosition;
			} else {
				SecondDrawingPassSize = 0;
				FirstDrawingPassSize = UPDATE_SIZE_VS;
			}

			if (content.m_Source == SRC_BMP_FILE) {
				DrawOverlayBitmapVert(Offset, NextUpdatePosition, FirstDrawingPassSize, pCCardDlg->lpDDSOverlayVScroll, &pCCardDlg->m_VScrollDibInfo, &content);
			} else {
				DrawOverlayTestPatternVert(Offset, NextUpdatePosition, FirstDrawingPassSize, pCCardDlg->lpDDSOverlayVScroll, &content);
			}

			if (pCCardDlg->pVScrollOvly->m_bFilter) {
				FilterStart.y = NextUpdatePosition - 1;	// Filter beginning with the last line of the
														//  previous pass.
				if (FilterStart.y < 0) {				// Wrap as needed.
					FilterStart.y = SRC_HEIGHT_VS - 1;
				}
				FilterSize.cy = FirstDrawingPassSize;
				ResetEvent(pCCardDlg->hEventVertFF);
				if (lpTulsaSurfaceExt->StartFlickerFilter(&FilterStart, &FilterSize, pCCardDlg->hEventVertFF) != DD_OK) {
					error++;
				}
				do {
					WaitForSingleObject(pCCardDlg->hEventVertFF, INFINITE /*100*/);
					lpTulsaSurfaceExt->GetFlickerFilterStatus(&bFinished, &Line);
				} while (!bFinished && pCCardDlg->bEnableVertScrollThread);
			}

			NextUpdatePosition += FirstDrawingPassSize;
			if (NextUpdatePosition >= SRC_HEIGHT_VS) {
				NextUpdatePosition = 0;
			}
			Offset += FirstDrawingPassSize;

			if (SecondDrawingPassSize > 0) {
				if (content.m_Source == SRC_BMP_FILE) {
					DrawOverlayBitmapVert(Offset, NextUpdatePosition, SecondDrawingPassSize, pCCardDlg->lpDDSOverlayVScroll, &pCCardDlg->m_VScrollDibInfo, &content);
				} else {
					DrawOverlayTestPatternVert(Offset, NextUpdatePosition, SecondDrawingPassSize, pCCardDlg->lpDDSOverlayVScroll, &content);
				}

				if (pCCardDlg->pVScrollOvly->m_bFilter) {

					FilterStart.y = NextUpdatePosition - 1;	// Filter beginning with the last line of the
															//  previous pass.
					if (FilterStart.y < 0) {				// Wrap as needed.
						FilterStart.y = SRC_HEIGHT_VS - 1;
					}
					FilterSize.cy = SecondDrawingPassSize;
					ResetEvent(pCCardDlg->hEventVertFF);
					if (lpTulsaSurfaceExt->StartFlickerFilter(&FilterStart, &FilterSize, pCCardDlg->hEventVertFF) != DD_OK) {
						error++;
					}
					do {
						WaitForSingleObject(pCCardDlg->hEventVertFF, INFINITE /*100*/);
						lpTulsaSurfaceExt->GetFlickerFilterStatus(&bFinished, &Line);
					} while (!bFinished && pCCardDlg->bEnableVertScrollThread);
				}

				NextUpdatePosition += SecondDrawingPassSize;
				Offset += SecondDrawingPassSize;
			}

			StopPoint = NextUpdatePosition - pCCardDlg->pVScrollOvly->m_Size.cy;
			if (StopPoint < 0) {
				StopPoint += SRC_HEIGHT_VS;
			}

			bUpdate = TRUE;

		} else if (pCCardDlg->m_bVSUpdate) {
			pCCardDlg->m_bVSUpdate = FALSE;
			bUpdate = TRUE;
		}

		if (bUpdate) {
			bUpdate = FALSE;
			SurfaceDescExt.dwFlags = SDE_SCROLL_VERT;
			SurfaceDescExt.lScrollPixelsPerStep = pCCardDlg->pVScrollOvly->m_PixelsPerStep;
			SurfaceDescExt.dwScrollVerticalsPerStep = pCCardDlg->pVScrollOvly->m_VerticalsPerStep;
			SurfaceDescExt.dwScrollPausePosition = StopPoint;
			SurfaceDescExt.dwScrollPosition = 0;

#ifdef TEST_ABS_NOTIF
			SurfaceDescExt.dwScrollNotifPosition = SurfaceDescExt.dwScrollPausePosition - 10;
			if (SurfaceDescExt.dwScrollNotifPosition < 0) {
				SurfaceDescExt.dwScrollNotifPosition += SRC_HEIGHT_VS;
			}

			SurfaceDescExt.dwScrollNotifIncrement = 0xffffffff;
#else
			if (SurfaceDescExt.lScrollPixelsPerStep > 0) {
				SurfaceDescExt.dwScrollNotifIncrement = (SRC_HEIGHT_VS - UPDATE_SIZE_VS - pCCardDlg->pVScrollOvly->m_Size.cy)/(2*SurfaceDescExt.lScrollPixelsPerStep);
				if (SurfaceDescExt.dwScrollNotifIncrement == 0) {
					SurfaceDescExt.dwScrollNotifIncrement = 1;
				}
			} else {
				SurfaceDescExt.dwScrollNotifIncrement = UPDATE_SIZE_VS;
			}
			SurfaceDescExt.dwScrollNotifPosition = 0xffffffff;
#endif
			SurfaceDescExt.hScrollEvent = pCCardDlg->hEventVertScroll;
			SurfaceDescExt.bPreserveDestAlpha = !pCCardDlg->pVScrollOvly->m_bWriteAlpha;
			lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

			DestRect.left = pCCardDlg->pVScrollOvly->m_Position.x;
			DestRect.top = WindowPosScrollArea; //pCCardDlg->pVScrollOvly->m_Position.y;
			DestRect.right = DestRect.left + pCCardDlg->pVScrollOvly->m_Size.cx - 1;
			DestRect.bottom = DestRect.top + pCCardDlg->pVScrollOvly->m_Size.cy - 1;

			pCCardDlg->lpDDSOverlayVScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, &DestRect, 
				DDOVER_SHOW | (pCCardDlg->pVScrollOvly->m_bBlend? DDOVER_ALPHASRC: 0) | 
				(pCCardDlg->pVScrollOvly->m_bInvBlend? DDOVER_ALPHASRCNEG: 0), NULL);

			if (pCCardDlg->VScrollZOrderFlags) {
				pCCardDlg->lpDDSOverlayVScroll->UpdateOverlayZOrder(pCCardDlg->VScrollZOrderFlags & 0xfffffff, NULL);
				pCCardDlg->VScrollZOrderFlags = 0;
			}
		}

		WaitForSingleObject(pCCardDlg->hEventVertScroll, INFINITE);
		ResetEvent(pCCardDlg->hEventVertScroll);

#ifdef READ_SCROLL_DEBUG_COUNTER
		DEBUG_SCROLL_INFO ScrollDebugInfo;
		lpTulsaSurfaceExt->GetScrollDebugInfo(&ScrollDebugInfo);
#endif

		WakeCnt++;


		if (pCCardDlg->m_ConfigPreset == PREVUE_DEMO_SETTINGS) {
			if (--MoveWindowDelay <= 0) {
				MoveWindowDelay = MOVE_WINDOW_DELAY;

																// Wait for pause position to be reached
				int PixelsFromPausePos;
				do {
					lpTulsaSurfaceExt->GetSurfaceDescExt(&SurfaceDescExt);
					PixelsFromPausePos = SurfaceDescExt.dwScrollPausePosition - SurfaceDescExt.dwScrollPosition;
					if (PixelsFromPausePos < 0) {
						PixelsFromPausePos += SRC_HEIGHT_VS;
					}
					Sleep(40);
																// Debug
					pCCardDlg->DbgVScrollPos = SurfaceDescExt.dwScrollPosition;

				} while (PixelsFromPausePos > SurfaceDescExt.lScrollPixelsPerStep &&
					pCCardDlg->bEnableVertScrollThread);

				int Delta;
				if (bMoveWindowUp) {
					Delta = -1;
				} else {
					Delta = 1;
				}
				for (int i = 0; i < 49; i++, WindowPosScrollArea += Delta, WindowPosTimebar += Delta) {
					DestRect.left = pCCardDlg->pVScrollOvly->m_Position.x;
					DestRect.top = WindowPosScrollArea; 
					DestRect.right = DestRect.left + pCCardDlg->pVScrollOvly->m_Size.cx - 1;
					DestRect.bottom = DestRect.top + pCCardDlg->pVScrollOvly->m_Size.cy - 1;

#ifdef TEST_SET_POSITION
					SurfaceDescExt.dwFlags = SDE_SCROLL_VERT | SDE_SCROLL_SET_SRC_POS;
					SurfaceDescExt.dwScrollPosition = 0;
					lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);
#endif

					pCCardDlg->lpDDSOverlayVScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, &DestRect, 
						DDOVER_SHOW | (pCCardDlg->pVScrollOvly->m_bBlend? DDOVER_ALPHASRC: 0) | 
						(pCCardDlg->pVScrollOvly->m_bInvBlend? DDOVER_ALPHASRCNEG: 0), NULL);


					DestRect.left = pCCardDlg->pVScrollOvly->m_Position.x;
					DestRect.top = WindowPosTimebar;
					DestRect.right = DestRect.left + pCCardDlg->pVScrollOvly->m_Size.cx - 1;
					DestRect.bottom = DestRect.top + TIMEBAR_HEIGHT - 1; //pCCardDlg->m_VScrollTimeBarDibInfo.dwHeight - 1;

					if (pCCardDlg->lpDDSOverlayTimebar) {
						pCCardDlg->lpDDSOverlayTimebar->UpdateOverlay(&SrcRectTB, pCCardDlg->lpDDSPrimaryRGB, 
						&DestRect, DDOVER_SHOW, NULL);
					}

					Sleep(16);
				}
				bMoveWindowUp = !bMoveWindowUp;
			}
		}

	}

	SurfaceDescExt.hScrollEvent = NULL;
	lpTulsaSurfaceExt->SetSurfaceDescExt(&SurfaceDescExt);

	pCCardDlg->lpDDSOverlayVScroll->UpdateOverlay(&SrcRect, pCCardDlg->lpDDSPrimaryRGB, &DestRect, 
		DDOVER_SHOW, NULL);

	HANDLE hEventTemp = pCCardDlg->hEventVertScroll;
	pCCardDlg->hEventVertScroll = NULL;
	CloseHandle(hEventTemp);

	hEventTemp = pCCardDlg->hEventVertFF;
	pCCardDlg->hEventVertFF = NULL;
	CloseHandle(hEventTemp);

	lpTulsaSurfaceExt->Release();
	lpTulsaSurfaceExt = NULL;

	pCCardDlg->lpDDSOverlayVScroll->Release();
	pCCardDlg->lpDDSOverlayVScroll = NULL;

	if (pCCardDlg->lpDDSOverlayTimebar) {
		pCCardDlg->lpDDSOverlayTimebar->Release();
		pCCardDlg->lpDDSOverlayTimebar = NULL;
	}

	pCCardDlg->bVertScrollThreadFinished = TRUE;

	CoUninitialize();

	return(0);
}


void CCardDlg::StartVertScrollTest(void)
{
	HRESULT ddrval;
	DDSURFACEDESC   ddsd;
    INIT_DIRECTDRAW_STRUCT(ddsd);

	if (bEnableVertScrollThread) {				
		return;							// Already enabled
	}

	if (pVScrollOvly->m_Content.m_Source == SRC_BMP_FILE) {
		ReadScrollBitmap(pVScrollOvly->m_Content.m_Filename, m_VScrollDibInfo);
	}

	VScrollReady = FALSE;

	ddsd.dwHeight = SRC_HEIGHT_VS;
	ddsd.dwWidth = SRC_WIDTH_VS;
	ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
	ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB;
	ddsd.ddpfPixelFormat.dwRGBBitCount = 32;
    ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
    ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY;
										// Create an overlay surface for graphics
	ddrval = lpDD2RGB->CreateSurface(&ddsd, &lpDDSOverlayVScroll, NULL);
	if (ddrval == DD_OK) {

		if (m_ConfigPreset == PREVUE_DEMO_SETTINGS) {
			ddsd.dwHeight = TIMEBAR_HEIGHT; 
			ddsd.dwWidth = TIMEBAR_WIDTH; 
			ddsd.ddpfPixelFormat.dwSize = sizeof(DDPIXELFORMAT);
			ddsd.ddpfPixelFormat.dwFlags = DDPF_RGB;
			ddsd.ddpfPixelFormat.dwRGBBitCount = 32;
			ddsd.dwFlags = DDSD_CAPS | DDSD_WIDTH | DDSD_HEIGHT | DDSD_PIXELFORMAT;
			ddsd.ddsCaps.dwCaps = DDSCAPS_OVERLAY;
			ddrval = lpDD2RGB->CreateSurface(&ddsd, &lpDDSOverlayTimebar, NULL);
			if (ddrval == DD_OK) {
				CGraphicsContent GraphicsContent;
				GraphicsContent.m_AlphaEffect = ALPHA_EFFECT_NONE;
				GraphicsContent.m_AlphaSource = ALPHA_SRC_GENERATE;
				strcpy(GraphicsContent.m_Filename, "timebar.bmp");
				GraphicsContent.m_Source = SRC_BMP_FILE;
				GraphicsContent.m_StartingAlpha = 0x00;

				DDSURFACEDESC SurfaceDesc;
				if (lpDDSOverlayTimebar->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {
					CopyBitmapFromFile(&SurfaceDesc, &GraphicsContent, TRUE);
					lpDDSOverlayTimebar->Unlock(NULL);
				}
			}
		} else {
			lpDDSOverlayTimebar = NULL;
		}

										// Copy bitmap onto surface and display
										//  with no blending or colorkeying
		DDSURFACEDESC SurfaceDesc;
		if (lpDDSOverlayVScroll->Lock(NULL, &SurfaceDesc, 0, NULL) == DD_OK) {
			lpDDSOverlayVScroll->Unlock(NULL);
		}
		
		bEnableVertScrollThread = TRUE;
		bVertScrollThreadFinished = FALSE;
		AfxBeginThread(VertScrollThread, (LPVOID)this, THREAD_PRIORITY_NORMAL);

										// Wait for scrolling to paint and flicker filter
										//  initial screen area
		while (!VScrollReady) {
			Sleep(10);
		}

	} else {
		FreeScrollBitmap(m_VScrollDibInfo);
		AfxMessageBox("Could not create overlay surface for vertical scrolling surface");
	}
}

void CCardDlg::StopVertScrollTest(void)
{
	if (bEnableVertScrollThread) {
		bEnableVertScrollThread = FALSE;

		if (hEventVertScroll) {
			SetEvent(hEventVertScroll);
		}
		if (hEventVertFF) {
			SetEvent(hEventVertFF);
		}

		for (int i = 0; /*i < 200 &&*/ !bVertScrollThreadFinished; i++) {
			Sleep(50);
		}

		if (!bVertScrollThreadFinished) {
			Sleep(50);
		}
		FreeScrollBitmap(m_VScrollDibInfo);
	}
}

void CCardDlg::UpdateVertScrollTest(void)
{
	if (bEnableVertScrollThread) {
		m_bVSUpdate = TRUE;
		if (hEventVertScroll) {
			SetEvent(hEventVertScroll);
		}
	}
}

BOOL CCardDlg::VertScrollEnabled(void)
{
	return(bEnableVertScrollThread);
}


